<template>
  <div class="activity-page h-100">
    <left-form-wrapper
      title="Восстановление доступа"
      background="1"
    >
      <transition
        name="fadeIn"
        @after-leave="afterLeaveForm"
      >
        <ObForm
          v-if="showForm"
          :form-data="formData"
          ok-text="Отправить ссылку для сброса пароля"
          :is-only-submit="true"
          :form-model="formModel"
          :is-on-press-enter-submit="true"
          @submit="sendFormData"
        >
          <div class="description">
            <p>
              Укажите адрес электронной почты,
              для которого вы хотите восстановить доступ
            </p>
          </div>
          <ObInput
            v-model="formData.email"
            class="mb10"
            label="Электронная почта"
            property="email"
            placeholder="Введите email"
          />
          <transition name="fadeIn">
            <div
              v-if="error"
              class="input-error-bottom"
            >
              {{ error }}
            </div>
          </transition>
        </ObForm>
      </transition>
      <transition name="fadeIn">
        <div v-if="sended">
          <p class="description">
            На указанный вами адрес отправлена ссылка для сброса пароля. Проверьте, пожалуйста, почту. Загляните в папку Спам, письмо могло оказаться там.
          </p>
          <ObButton
            class="w-100"
            label="На страницу входа"
            :to="{ name: 'login' }"
          />
        </div>
      </transition>
    </left-form-wrapper>
  </div>
</template>

<script>
import LeftFormWrapper from '../../components/LeftFormWrapper/index'
import ObForm from 'common-components/src/obComponents/obForm'
import ObButton from 'common-components/src/obComponents/obButton'
import ObInput from 'common-components/src/obComponents/obInput'
import routeMixin from '../../mixins/route-mixin'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import api from '@/api'
import { email } from 'vuelidate/lib/validators'

export default {
  name: 'RestorePage',
  components: {
    ObForm,
    LeftFormWrapper,
    ObButton,
    ObInput
  },
  mixins: [
    routeMixin,
    FormValidationMixin
  ],
  data () {
    return {
      sended: false,
      showForm: true,
      error: null
    }
  },
  computed: {
    formModel () {
      return {
        email: {
          value: '',
          validator: {
            email: {
              method: email,
              error: 'Некорректный email'
            }
          }
        }
      }
    }
  },
  watch: {
    'formData.email' () {
      if (this.error) {
        this.error = null
      }
    }
  },
  mounted () {
    this.formData.email = this.$route.query.email || ''
  },
  methods: {
    async sendFormData () {
      this.error = null
      try {
        await api.registration.auth.getRestorePasswordLink({ email: this.formData.email })
        this.formData.email = ''
        this.showForm = false
      } catch (e) {
        this.error = 'Не найдено участника с указанным email'
      }
    },
    afterLeaveForm () {
      this.sended = true
    }
  },
  metaInfo() {
    return {
      meta: [
        { name: 'yandex', content: 'noindex, nofollow' }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .description {
    @include font-mixin(16px, 24px, 700, inherit, 0.4px);
    margin-bottom: 20px;

    p {
      margin-bottom: 12px;
    }
  }
</style>
